function [CumulativeTradeVol FinalTradeMatrix TradingNetwork] = EVwithShocks(t,NumberOfShocks,PSM,EEV,TR,EndowOfLiquidity);

n = size(TR,1);
EdogVal = EEV;
[c r] = find(TR == 1);
DataSet = [];
TradingNetwork = zeros(n);
LinkagesWeights = zeros(n);
CumulativeTradeVol = zeros(n);
FinalTradeMatrix = zeros(n);
EV = zeros(n,1);

if PSM == 1;
    for i = 1:NumberOfShocks;%%% Shocks
        EndowOfLiquidity = EndowmentOfLiquidity(TR);
        PV = rand(n,1);
        i
        for j = 1:1; %%% Interrations to equilibrium
            
            %%%%Edogenous Value
            for k = 1:n; %%% Bank
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EdogVal(TradingPartners)];
                BorrwerEdog = DateSet(:,2);
                MaxEdog = max(BorrwerEdog);
                EV_Temp = PV(k)+0.5*(MaxEdog-PV(k));
                EV(k) = max(PV(k),EV_Temp);   
            end
            
            %%%Trading Partners
            for k = 1:n;
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EV(TradingPartners)];
                Self = [k EV(k)];
                DateSetWithSelf = [DateSet;Self];
                MaxEdog = max(DateSetWithSelf(:,2));
                Location = find(DateSetWithSelf(:,2) == MaxEdog);
                TradingPartner = DateSetWithSelf(Location,1);
                
                LocationSelf = find(TradingPartner == k);
                if isempty(LocationSelf) == 1;
                    FinalPartner = UniformSelect(TradingPartner);
                else
                    if length(TradingPartner) > 1;
                        TradingPartner(LocationSelf) = [];
                        FinalPartner = UniformSelect(TradingPartner);
                    else
                        FinalPartner = k;
                    end
                end
                
                %%%% Flow from k to FinalPartner
                if FinalPartner ~= k;
                    if EndowOfLiquidity(k) >0;
                        TradingNetwork(k,FinalPartner) = 1;
                        LinkagesWeights(k,FinalPartner) = EndowOfLiquidity(k);
                        EndowOfLiquidity(FinalPartner) = EndowOfLiquidity(FinalPartner)+...
                            EndowOfLiquidity(k);
                        EndowOfLiquidity(k) = 0;
                    end
                end
            end
            
            %%%%Total trade volumn after w shocks
            CumulativeTradeVol = CumulativeTradeVol + LinkagesWeights;      
        end
        
    end
    
    for i = 1:n;
        for j = 1:n;
            if CumulativeTradeVol(i,j) > t;
               FinalTradeMatrix(i,j) = 1;
            end
        end
    end
end

if PSM == 2;
    for i = 1:NumberOfShocks;%%% Shocks
        EndowOfLiquidity = EndowmentOfLiquidity(TR);
        PV = rand(n,1);
        i
        for j = 1:1; %%% Interrations to equilibrium
            
            %%%%Edogenous Value
            for k = 1:n; %%% Bank
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EdogVal(TradingPartners)];
                BorrwerEdog = DateSet(:,2);
                MaxEdog = max(BorrwerEdog);
                EV_Temp = PV(k)+(1-0.5/sum(TR(k,:)))*(MaxEdog-PV(k));
                EV(k) = max(PV(k),EV_Temp);   
            end
            
            %%%Trading Partners
            for k = 1:n;
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EV(TradingPartners)];
                Self = [k EV(k)];
                DateSetWithSelf = [DateSet;Self];
                MaxEdog = max(DateSetWithSelf(:,2));
                Location = find(DateSetWithSelf(:,2) == MaxEdog);
                TradingPartner = DateSetWithSelf(Location,1);
                
                LocationSelf = find(TradingPartner == k);
                if isempty(LocationSelf) == 1;
                    FinalPartner = UniformSelect(TradingPartner);
                else
                    if length(TradingPartner) > 1;
                        TradingPartner(LocationSelf) = [];
                        FinalPartner = UniformSelect(TradingPartner);
                    else
                        FinalPartner = k;
                    end
                end
                
                %%%% Flow from k to FinalPartner
                if FinalPartner ~= k;
                    if EndowOfLiquidity(k) >0;
                        TradingNetwork(k,FinalPartner) = 1;
                        LinkagesWeights(k,FinalPartner) = EndowOfLiquidity(k);
                        EndowOfLiquidity(FinalPartner) = EndowOfLiquidity(FinalPartner)+...
                            EndowOfLiquidity(k);
                        EndowOfLiquidity(k) = 0;
                    end
                end
            end
            
            %%%%Total trade volumn after w shocks
            CumulativeTradeVol = CumulativeTradeVol + LinkagesWeights;      
        end
        
    end
    
    for i = 1:n;
        for j = 1:n;
            if CumulativeTradeVol(i,j) > t;
               FinalTradeMatrix(i,j) = 1;
            end
        end
    end
end

if PSM == 3;
    for i = 1:NumberOfShocks;%%% Shocks
        EndowOfLiquidity = EndowmentOfLiquidity(TR);
        PV = rand(n,1);
        i
        for j = 1:1; %%% Interrations to equilibrium
            
            %%%%Edogenous Value
            for k = 1:n; %%% Bank
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EdogVal(TradingPartners)];
                BorrwerEdog = DateSet(:,2);
                MaxEdog = max(BorrwerEdog);
                PartnerLocation = find(DateSet(:,2) == MaxEdog);
                FinalPartner = DateSet(UniformSelect(PartnerLocation),1);
                EV_Temp = PV(k)+(sum(TR(k,:))/(sum(TR(k,:))+sum(TR(FinalPartner,:))))*(MaxEdog-PV(k));
                EV(k) = max(PV(k),EV_Temp);   
            end
            
            %%%Trading Partners
            for k = 1:n;
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EV(TradingPartners)];
                Self = [k EV(k)];
                DateSetWithSelf = [DateSet;Self];
                MaxEdog = max(DateSetWithSelf(:,2));
                Location = find(DateSetWithSelf(:,2) == MaxEdog);
                TradingPartner = DateSetWithSelf(Location,1);
                
                LocationSelf = find(TradingPartner == k);
                if isempty(LocationSelf) == 1;
                    FinalPartner = UniformSelect(TradingPartner);
                else
                    if length(TradingPartner) > 1;
                        TradingPartner(LocationSelf) = [];
                        FinalPartner = UniformSelect(TradingPartner);
                    else
                        FinalPartner = k;
                    end
                end
                
                %%%% Flow from k to FinalPartner
                if FinalPartner ~= k;
                    if EndowOfLiquidity(k) >0;
                        TradingNetwork(k,FinalPartner) = 1;
                        LinkagesWeights(k,FinalPartner) = EndowOfLiquidity(k);
                        EndowOfLiquidity(FinalPartner) = EndowOfLiquidity(FinalPartner)+...
                            EndowOfLiquidity(k);
                        EndowOfLiquidity(k) = 0;
                    end
                end
            end
            
            %%%%Total trade volumn after w shocks
            CumulativeTradeVol = CumulativeTradeVol + LinkagesWeights;      
        end
        
    end
    
    for i = 1:n;
        for j = 1:n;
            if CumulativeTradeVol(i,j) > t;
               FinalTradeMatrix(i,j) = 1;
            end
        end
    end
end

if PSM == 4;
    for i = 1:NumberOfShocks;%%% Shocks
        EndowOfLiquidity = EndowmentOfLiquidity(TR);
        PV = rand(n,1);
        i
        for j = 1:1; %%% Interrations to equilibrium
            
            %%%%Edogenous Value
            %%%%Second Best
            for k = 1:n; %%% Bank
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EdogVal(TradingPartners)];
                
                BorrwerEdog = DateSet(:,2);
                MaxEdog = max(BorrwerEdog);
                
                if length(BorrwerEdog(BorrwerEdog < MaxEdog)) ~= 0;  
                    SecondBest = max(BorrwerEdog(BorrwerEdog < MaxEdog));
                else
                    SecondBest = MaxEdog;
                end
                
                EV(k) = max(PV(k),SecondBest);   
            end
            
            %%%Trading Partners
            for k = 1:n;
                Location = find(r==k);
                TradingPartners = c(Location);
                DateSet = [TradingPartners EV(TradingPartners)];
                Self = [k EV(k)];
                DateSetWithSelf = [DateSet;Self];
                MaxEdog = max(DateSetWithSelf(:,2));
                Location = find(DateSetWithSelf(:,2) == MaxEdog);
                TradingPartner = DateSetWithSelf(Location,1);
                
                LocationSelf = find(TradingPartner == k);
                if isempty(LocationSelf) == 1;
                    FinalPartner = UniformSelect(TradingPartner);
                else
                    if length(TradingPartner) > 1;
                        TradingPartner(LocationSelf) = [];
                        FinalPartner = UniformSelect(TradingPartner);
                    else
                        FinalPartner = k;
                    end
                end
                
                %%%% Flow from k to FinalPartner
                if FinalPartner ~= k;
                    if EndowOfLiquidity(k) >0;
                        TradingNetwork(k,FinalPartner) = 1;
                        LinkagesWeights(k,FinalPartner) = EndowOfLiquidity(k);
                        EndowOfLiquidity(FinalPartner) = EndowOfLiquidity(FinalPartner)+...
                            EndowOfLiquidity(k);
                        EndowOfLiquidity(k) = 0;
                    end
                end
            end
            
            %%%%Total trade volumn after w shocks
            CumulativeTradeVol = CumulativeTradeVol + LinkagesWeights;      
        end
        
    end
    
    for i = 1:n;
        for j = 1:n;
            if CumulativeTradeVol(i,j) > t;
               FinalTradeMatrix(i,j) = 1;
            end
        end
    end
end
