function [EdogVal] = EquilEV(PSM,TR,PV);

n = size(TR,1);
[c r] = find(TR == 1);
EdogVal = PV;
DataTable = [];
EV = zeros(n,1);

if PSM == 1;
    for j = 1:10;
        for i = 1:n;
            Location = find(r==i);
            TradingPartners = c(Location);
            BorrwerEdog = EdogVal(TradingPartners);
            MaxEdog = max(BorrwerEdog);            
            EV_Temp = PV(i)+0.5*(MaxEdog-PV(i));
            EV(i) = max(PV(i), EV_Temp);
        end
        EdogVal = EV;
    end
end

if PSM == 2;
    for j = 1:10;
        for i = 1:n;
            Location = find(r==i);
            TradingPartners = c(Location);
            BorrwerEdog = EdogVal(TradingPartners);
            MaxEdog = max(BorrwerEdog);            
            EV_Temp = PV(i)+(1-0.5/sum(TR(i,:)))*(MaxEdog-PV(i));
            EV(i) = max(PV(i), EV_Temp);
        end
        EdogVal = EV;
    end
end

if PSM == 3;
    for j = 1:10;
        for i = 1:n;
            Location = find(r==i);
            TradingPartners = c(Location);
            BorrwerEdog = EdogVal(TradingPartners);
            MaxEdog = max(BorrwerEdog); 
            DataTable = [TradingPartners EdogVal(TradingPartners)];
            TargetRow = find(DataTable(:,2) == MaxEdog);
            TradingPartner = UniformSelect(TargetRow);
            FinalPartner = DataTable(TradingPartner,1);     
            EV_Temp = PV(i)+(sum(TR(i,:))/(sum(TR(i,:))+sum(TR(FinalPartner,:))))*(MaxEdog-PV(i));
            EV(i) = max(PV(i), EV_Temp);
        end
        EdogVal = EV;
    end
end

if PSM == 4;
    for j = 1:10;
        for i = 1:n;
            Location = find(r==i);
            TradingPartners = c(Location);
            BorrwerEdog = EdogVal(TradingPartners);
            MaxEdog = max(BorrwerEdog);
            
            if length(BorrwerEdog(BorrwerEdog < MaxEdog)) ~= 0;  
                EV_Temp = max(BorrwerEdog(BorrwerEdog < max(BorrwerEdog)));
            else
                EV_Temp = MaxEdog;
            end   
            
            EV(i) = max(PV(i), EV_Temp);
        end
        EdogVal = EV;
    end
end