function [TR]=FormationOfTR(n,m);
%%%%%%Consider a network with n banks and m core banks, where n>m
TR = zeros(n,n);
D = zeros(n,1);

%%%Core banks are completely connected
for i_TR = 1:m;
    for j_TR = 1:m;
        TR(i_TR,j_TR) = 1;
    end
end
TR = TR - diag(diag(TR));



for i = (m+1):n;
    
    BankName = [1:(i-1)]';
    
    for i_D = 1:n;
        D(i_D) = sum(TR(i_D,:));
    end

    DegreeTotal = sum(D(1:(i-1)));
    Prob = D(1:(i-1))/DegreeTotal; %%%%%Prob for each trading partner
    CDF_B = CDFTramsform(BankName,Prob);

    %%%%Choose m banks from i-1 banks
    for TPL = 1:m;
        
        Rand = rand();
        TP = 0;
        if Rand <= CDF_B(1,2);
            TP = CDF_B(1,1);
        else
            for TP_Temp = 1:(size(CDF_B,1)-1); 
                if Rand<=CDF_B(TP_Temp+1,2) && Rand>CDF_B(TP_Temp,2);
                    TP = CDF_B(TP_Temp+1,1);
                end
            end
        end
        
        TR(TP,i) = 1;
        TR(i,TP) = 1;
        
        Location = find(CDF_B(:,1)==TP);
        Prob (Location) = [];
        BankName(Location) = [];
        
        Prob = PDFTransform (Prob);
        CDF_B = CDFTramsform(BankName,Prob);
    end
end

        

    
    
    
    
    
    
    
    